local _, cClass = UnitClass("player")

if (cClass ~= "ROGUE") then
	return
end

local QuartzProc = Quartz:GetModule('Procs')

function QuartzProc:returnProcList()
local tmpList = {
		[63848] = { -- Hunger for Blood
			name = GetSpellInfo(63848),
			length = 60,
			color = {0.7, 0.1, 0.1}, -- red-ish
		},
		[11305] = { -- Sprint
			name = GetSpellInfo(11305),
			length = 15,
			color = {0, 1, 0}, -- green
		},
		[13750] = { -- Adrenline Rush
			name = GetSpellInfo(13750),
			length = 15,
			color = {0.7, 0.1, 0.1}, -- red-ish
		},
		[13877] = { -- Blade Flurry
			name = GetSpellInfo(13877),
			length = 15,
			color = {1, 0.5, 0}, -- orange-ish
		},
		[31224] = { -- Cloak of Shadows
			name = GetSpellInfo(31224),
			length = 5,
			color = {1, 0, 0.5}, --purple-ish
		},
		[26669] = { -- Evasion
			name = GetSpellInfo(26669),
			length = 15,
			color = {0.93, 0.98, 0.51}, -- Light-Goldenrod
		},
		[36563] = { -- ShadowStep (dmg buff)
			name = GetSpellInfo(36563) .. " (dmg)",
			length = 10,
			color = {1, 0, 0.5}, --purple-ish
		},
		[36554] = { -- ShadowStep (speed)
			name = GetSpellInfo(36554) .. " (speed)",
			length = 3,
			color = {1, 0, 0.5}, --purple-ish
		},
		[26888] = { -- Vanish
			name = GetSpellInfo(26888),
			length = 10,
			color = {0.28, 0.24, 0.55}, -- darkslate blue
		},
		[51690] = { -- Killing Spree
			name = GetSpellInfo(51690),
			length = 2.5,
			color = {0.7, 0.1, 0.1}, -- red-ish
		},
		[45182] = { -- Cheat Death *untested*
			name = GetSpellInfo(45182),
			length = 3,
			color = {0.7, 0.1, 0.1}, -- red-ish
		},
		
		--Rogue: Slice and Dice (Rank 2)
		--(don't need rank 1 in here, it still catch it from the name from Rank2)
		[6774] = {
			name = GetSpellInfo(6774),
			color = {1, 0.5, 0}, -- orange-ish
			expires = 0,
			isAura = true,
		},
		--Rogue: Shadow Dance
		[51713] = { 
			name = GetSpellInfo(51713),
			color = {0.7, 0.1, 0.1}, -- red-ish
			expires = 0,
			isAura = true,
		},
		[57934] = { -- TotT applied to Rogue
			name = GetSpellInfo(57934) .. " (pre-buff)",
			color = {0.7, 0.1, 0.1}, -- red-ish
			length = 30,
		},
		[59628] = { -- TotT triggered by attack
			name = GetSpellInfo(59628) .. " (activated)",
			color = {0.1, 0.7, 0.1}, -- red-ish
			length = 6,
		},
		
		[48659] = { -- Feint, aoe dmg reduction buff
			name = GetSpellInfo(48659),
			color = {0.4, 0.4, 1}, --
			length = 6,
		}
}
return tmpList
end