--local L = AceLibrary("AceLocale-2.2"):new("Quartz_Procs")
--
--
--[[
* TODO: 

* warlock: insta shadowbolt, incinerate, nether protection
* mage: mana shield, incanter's absorption, slowfall (self)
* hunter: mend pet

*** v3.0 ***
-New configuration. Uses Ace3 and config is added to blizzard's addon manager
-New slashs commands /procs and /quartzprocs (for opening the config)
-Class procs and General procs seperated now
-New custom procs
-Cleaned up configuration code a bit (still needs alot more attention)
-New code for UNIT_AURA event. Watches for buffs/procs that gets removed
(this was needed for the workarounds for the combatlog bug, but its a nice feature to have anyways)

NewSpells
-Arcane Blast debuff (turned off by default)
-Druid T10 Procs (OoD, Languish)
-Verdict rings
-Predatory Strikes length fixed

WorkArounds (spells that are fixed now)
-Eclipse
-Missile Barrage
-Brain Freeze
-Hot Streak
-Bloodsurge
-Sword and Board
-Slam! (Triggered by Bloodsurge)

TODO:
-Test sacred shield... had a weird hacky way of checking for it before but i removed all that
code since i believe the spell changed and plus, you can get spellid from UnitAura() now
-Move the configuration into a seperate addon... i'll do this when i get motivated enough
to optimize the code :)
-Lots more testing needed for custom procs... so far it doesn't support anything that stacks
and possibly alot of other procs (right now it just checks for the spellID in the UnitAura)
-Allow custom procs to be made without the need of spellID, just using the name
-Make sure all the workarounds are in place (could have missed a few)
-Customize cooldown bars (color, name?, add icon?)
-Probably some rank issues with IsAura now... since it uses spellID, I think i need to fix this for sure...


*** v2.2 ***
seperated class data into it's own file
changed options around, you can only configure the options of the current class you are using
- (i want to change this so it has categories for each class, like for druid... Feral, Balance, Resto, etc)
optionsOrder added so you can put the general options on the bottom of the list
link and linked added
- link 1 controls all the linked items (for the options)
elemental oath added (and disabled by default)
--]]
--

QuartzProc = LibStub("AceAddon-3.0"):NewAddon("QuartzProc", "AceConsole-3.0")

local Quartz = Quartz
if Quartz:HasModule('Procs') then
	return
end

local QuartzCustomTimer = Quartz:NewModule('Procs', 'AceHook-2.1')
local self = QuartzCustomTimer

local m = Quartz:GetModule('Mirror')
local QP = Quartz:GetModule('Player')
local ex = m.ExternalTimers
local new, del = Quartz.new, Quartz.del

local db = Quartz:AcquireDBNamespace("Procs3")

local _, curClass = UnitClass("player")
local procs_List
local spellsWatch = {}
local ProcList = {}
local CustomOptions = {}

local fproc
local tproc

procs_List = {
	General = {
		[32182] = { -- Heroism
			name = GetSpellInfo(32182),
			length = 40,
			color = {1, 0.65, 0}, -- orange
			optionsOrder = 501,
			ptype = 'general',
		},
		[2825] = { -- Bloodlust
			name = GetSpellInfo(2825),
			length = 40,
			color = {1, 0.65, 0}, -- orange
			optionsOrder = 511,
			ptype = 'general',
		},
		
		[35079] = { -- Misdirection, threat directed to (this) target
			name = GetSpellInfo(35079) .. " (target)",
			color = {1, 0, 0}, -- (warning) red
			length = 30,
			optionsOrder = 521,
			ptype = 'general',
		},
		[57933] = { -- TotT, threat directed to (this) target
			name = GetSpellInfo(57933) .. " (target)",
			color = {1, 0, 0}, -- (warning) red
			length = 6,
			optionsOrder = 531,
			ptype = 'general',
		},
		
		-- Verdict Rings
		[72412] = { -- Frostforged Champion 
			name = GetSpellInfo(72412), 
			length = 10, 
			color = {1, 0.65, 0}, -- orange 
			optionsOrder = 541,
			ptype = 'general',
		}, 
		[72414] = { -- Frostforged Defender 
			name = GetSpellInfo(72414), 
			length = 10, 
			color = {1, 0.65, 0}, -- orange 
			optionsOrder = 551,
			ptype = 'general',
		}, 
		[72416] = { -- Frostforged Sage 
			name = GetSpellInfo(72416), 
			length = 10, 
			color = {1, 0.65, 0}, -- orange 
			optionsOrder = 561,
			ptype = 'general',
		}, 
		[72418] = { -- Item - Icecrown Reputation Ring Healer Effect 
			name = GetSpellInfo(72418), 
			length = 10, 
			color = {1, 0.65, 0}, -- orange 
			optionsOrder = 571,
			ptype = 'general',
		},
		
	}
}


local function getLeaf(info)
	return CustomOptions.args[info[1]]
end


function QuartzCustomTimer:OnInitialize()
	local function joinTablesNew()
		for k,v in pairs(procs_List.General) do
			table.insert(ProcList, k, v)
		end
		-- insert all the custom spells from db into the table
		for cSpellID,cSpell in pairs(db.profile.custom) do
			table.insert(ProcList, cSpellID, cSpell)
		end

		return ProcList
	end
	
	local tmpList = self:returnProcList()
	for k, v in pairs(tmpList) do
		local tmptmpList = {}
		for nk, nv in pairs(v) do
			tmptmpList[nk] = nv
		end
		ProcList[k] = tmptmpList
	end
	
	--Setup the spellsWatch value to hold current table for that class
	spellsWatch = joinTablesNew()
	--
	
	Quartz:RegisterDefaults("Procs3", "profile", {
		active = true,
		[35079] = {
			enabled = false,
		},
		[57933] = {
			enabled = false,
		},
		[53414] = {
			enabled = false,
		},
		[36032] = { -- Arcane Blast
			enabled = false,
		},
	})
	
	
	local function set(info, value)
		local field = tonumber(info.arg)
		
		if (value ~= nil) then
			if (db.profile[field] ~= nil) then
				if (ProcList[tonumber(field)].link ~= nil) then
					for i,v in ipairs(ProcList[tonumber(field)].linked) do
						if (db.profile[v] == nil) then
							db.profile[v] = { enabled = value }
						else
							db.profile[v].enabled = value
						end
					end
				else
					db.profile[field].enabled = value
				end
			else
				if (ProcList[tonumber(field)].link ~= nil) then
					for i,v in ipairs(ProcList[tonumber(field)].linked) do
						if (db.profile[v] == nil) then
							db.profile[v] = { enabled = value }
						else
							db.profile[v].enabled = value
						end
					end
				else
					db.profile[field] = {
						enabled = value
					}
				end
			end
		else
			if (db.profile[field] ~= nil) then
				if (ProcList[tonumber(field)].link ~= nil) then
					for i,v in ipairs(ProcList[tonumber(field)].linked) do
						if (db.profile[v] == nil) then
							db.profile[v] = { enabled = value }
						else
							db.profile[v].enabled = value
						end
					end
				else
					db.profile[field].enabled = false
				end
			else
				if (ProcList[tonumber(field)].link ~= nil) then
					for i,v in ipairs(ProcList[tonumber(field)].linked) do
						if (db.profile[v] == nil) then
							db.profile[v] = { enabled = value }
						else
							db.profile[v].enabled = value
						end
					end
				else
					db.profile[field] = {
						enabled = false
					}
				end
			end
		end
	end
	local function get(info)
		local field = tonumber(info.arg)
		
		if db.profile[field] ~= nil and db.profile[field].enabled ~= nil then
			return db.profile[field].enabled
		else
			return true
		end
	end
	local function setcolor(info, ...)
		local field = tonumber(info.arg)
		
		if (db.profile[field] == nil) then
			if (ProcList[tonumber(field)].link ~= nil) then
				for i,v in ipairs(ProcList[tonumber(field)].linked) do
					if (db.profile[v] == nil) then
						db.profile[v] = { color = {...} }
					else
						db.profile[v].color = {...}
					end
				end
			else
				db.profile[field] = {
					color = {...}
				}
			end
		else
			if (ProcList[tonumber(field)].link ~= nil) then
				for i,v in ipairs(ProcList[tonumber(field)].linked) do
					if (db.profile[v] == nil) then
						db.profile[v] = { color = {...} }
					else
						db.profile[v].color = {...}
					end
				end
			else
				db.profile[field].color = {...}
			end
		end
	end
	local function getcolor(info)
		local field = tonumber(info.arg)
		
		if db.profile[field] ~= nil and db.profile[field].color ~= nil then
			return unpack(db.profile[field].color)
		elseif ProcList[field] then
			return unpack(ProcList[field].color)
		else
			error("[" .. tostring(field) .. "] is nil")
			return {1,0,0}
		end
	end
	
	local function setsound(info, value)
		local field = tonumber(info.arg)
		
		if db.profile[field] == nil then
			if (ProcList[tonumber(field)].link ~= nil) then
				for i,v in ipairs(ProcList[tonumber(field)].linked) do
					if (db.profile[v] == nil) then
						db.profile[v] = { sound = value }
					else
						db.profile[v].sound = value
					end
				end
			else
				db.profile[field] = {
					sound = value
				}
			end
		else
			if (ProcList[tonumber(field)].link ~= nil) then
				for i,v in ipairs(ProcList[tonumber(field)].linked) do
					if (db.profile[v] == nil) then
						db.profile[v] = { sound = value }
					else
						db.profile[v].sound = value
					end
				end
			else
				db.profile[field].sound = value
			end
		end
	end
	local function getsound(info)
		local field = tonumber(info.arg)
		
		if db.profile[field] ~= nil and db.profile[field].sound ~= nil then
			return db.profile[field].sound
		elseif ProcList[tonumber(field)] then
			if (ProcList[tonumber(field)].playsound ~= nil) and (ProcList[tonumber(field)].playsound ~= "") then
				return ProcList[tonumber(field)].playsound
			end
			return "NONE"
		else
			error(field.." is nil")
			return "NONE"
		end
	end
	
	local function setname(info, value)
		local field = tonumber(info.arg)
		
		if (db.profile[field] == nil) then
			if (ProcList[tonumber(field)].link ~= nil) then
				for i,v in ipairs(ProcList[tonumber(field)].linked) do
					if (db.profile[v] == nil) then
						db.profile[v] = { name = value }
					else
						db.profile[v].name = value
					end
				end
			else
				db.profile[field] = {
					name = value
				}
			end
		else
			if (ProcList[tonumber(field)].link ~= nil) then
				for i,v in ipairs(ProcList[tonumber(field)].linked) do
					if (db.profile[v] == nil) then
						db.profile[v] = { name = value }
					else
						db.profile[v].name = value
					end
				end
			else
				db.profile[field].name = value
			end
		end
	end
	local function getname(info)
		local field = tonumber(info.arg)
		
		if (db.profile[field] ~= nil) and (db.profile[field].name ~= nil) then
			return db.profile[field].name
		elseif ProcList[tonumber(field)] then
			return ProcList[tonumber(field)].name
		else
			error(field.." is nil")
			return "nil"
		end
	end
	
	
	
	local cTmpName, cTmpSpellID
	local cTmpColor = {0,0,0,1}
	
	local spellCustomOptions = {
		cToggle = {
			type = 'toggle',
			name = 'Enabled',
			desc = 'Enable/Disable',
			get = function(info)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					if (db.profile.custom[getLeaf(info).arg].enabled ~= nil) then
						return db.profile.custom[getLeaf(info).arg].enabled
					else
						return true
					end
				end
				return true
			end,
			set = function(info, v)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					db.profile.custom[getLeaf(info).arg].enabled = v
				end
			end,
			order = 10,
		},
		cName = {
			type = 'input',
			name = 'Name',
			get = function(info)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					return db.profile.custom[getLeaf(info).arg].name or ''
				end
				return 'deleted'
			end,
			set = function(info, v)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					db.profile.custom[getLeaf(info).arg].name = v
				end
			end,
			order = 20,
		},
		cColor = {
			type = 'color',
			name = 'color',
			get = function(info)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					return unpack(db.profile.custom[getLeaf(info).arg].color)
				end
				return {1,0,0}
			end,
			set = function(info, ...)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					db.profile.custom[getLeaf(info).arg].color = {...}
				end
			end,
			order = 30,
		},
		cSpellID = {
			type = 'input',
			name = 'Spell ID',
			get = function(info)
				return getLeaf(info).arg or '0'
			end,
			order = 40,
		},
		cDelBtn = {
			type = 'execute',
			name = 'Delete',
			func = function(info)
				local sKey = getLeaf(info).arg
				print("Removed custom proc ("..sKey..")")
				db.profile.custom[sKey] = nil
				CustomOptions.args[info[1]] = nil
				spellsWatch[tonumber(sKey)] = nil
			end,
			order = 50,
		},
	}

	
	CustomOptions = {
		type = 'group',
		name = "Custom Procs",
		desc = "Custom Procs",
		args = {},
	}
	
	--Option to add new Proc
	CustomOptions.args["AddNewProc"] = {
		type = 'group',
		name = 'Add Proc',
		desc = 'Add a new proc',
		order = 1,
		args = {
			cName = {
				type = 'input',
				name = 'Name',
				get = function()
					return cTmpName or ''
				end,
				set = function(info, v)
					cTmpName = v
				end,
				usage = '',
				order = 20,
			},
			cColor = {
				type = 'color',
				name = 'color',
				get = function()
					return unpack(cTmpColor)
				end,
				set = function(info, ...)
					cTmpColor = {...}
				end,
				order = 30,
			},
			cSpellID = {
				type = 'input',
				name = 'Spell ID',
				get = function()
					return cTmpSpellID or "0"
				end,
				set = function(info, v)
					cTmpSpellID = v
				end,
				--validate = function(info, v)
					--print("Test2:: ["..v.."]")
					--return tonumber(v)
				--end,
				usage = '',
				order = 40,
			},
			cAddBtn = {
				type = 'execute',
				name = 'Add',
				func = function()
					local tmpTbl = {
						name = cTmpName,
						color = cTmpColor,
						expires = 0,
						isAura = true,
						ptype = 'custom',
					}
					db.profile.custom[cTmpSpellID] = {
						name = cTmpName,
						color = cTmpColor,
						expires = 0,
						isAura = true,
						ptype = 'custom',
					}
					
					table.insert(spellsWatch, cTmpSpellID, tmpTbl)
					CustomOptions.args[cTmpSpellID] = {
						type = 'group',
						name = cTmpName,
						desc = cTmpName .. " (" .. cTmpSpellID .. ")",
						arg = tostring(cTmpSpellID),
						order = 100,
						args = spellCustomOptions,
					}
					
					print("Added '"..cTmpName.."' ("..cTmpSpellID..")")
					cTmpName = ""
					cTmpSpellID = "0"
				end,
				order = 50,
			},
			cResetBtn = {
				type = 'execute',
				name = 'Reset',
				func = function()
					cTmpName = ""
					cTmpSpellID = "0"
				end,
				order = 60,
			},
		},
	}
	
	for spellid,spell in pairs(db.profile.custom) do
		if (spell.ptype == 'custom') then
			CustomOptions.args[tostring(spellid)] = {
				type = 'group',
				name = spell.name,
				desc = spell.name .. " (" .. spellid .. ")",
				arg = tostring(spellid),
				order = 100,
				args = spellCustomOptions,
			}
		end
	end
	-- End Custom Spell Options
	
	local spellargs = {}
	spellargs = {
		type = 'group',
		name = "Procs for "..curClass,
		desc = "Procs for "..curClass,
		args = {},
	}
	for spellid,spell in pairs(ProcList) do
		if (spell.ptype == nil) or ((spell.ptype ~= 'custom') and (spell.ptype ~= 'general')) then
			-- checking for "link" spells (ones with different ranks but are linked together cause they are the same spell essentially)
			if ((spell.link == nil) or ((spell.link ~= nil) and (spell.link == 1))) then
				spellargs.args[tostring(spellid)] = {
					type = 'group',
					name = spell.name,
					desc = spell.name,
					order = spell.optionsOrder or 1,
					args = {
						spellToggle = {
							type = 'toggle',
							name = 'Enabled',
							desc = 'Enable/Disable',
							get = get,
							set = set,
							order = 10,
							arg = tostring(spellid),
						},
						
						spellText = {
							type = 'input',
							name = spell.name,
							desc = 'name of spell',
							get = getname,
							set = setname,
							order = 20,
							arg = tostring(spellid),
						},
						
						spellColor = {
							type = 'color',
							name = 'Color',
							desc = 'color',
							get = getcolor,
							set = setcolor,
							order = 30,
							arg = tostring(spellid),
						},
						
						spellSound = {
							type = 'select',
							name = 'Sound',
							desc = 'Sound to make when proc occurs',
							get = getsound,
							set = setsound,
							order = 40,
							values = {["NONE"] = "None", ["SUNWELL_FEL_PORTALSTAND"] = "Sunwell_Fel_PortalStand", ["SEEPINGGASEOUS_FEL_NOVA"] = "SeepingGaseous_Fel_Nova", ["RAIDWARNING"] = "RaidWarning", ["READYCHECK"] = "ReadyCheck", ["PVPFLAGTAKENHORDEMONO"] = "PVPFlagTakenHordeMono",},
							arg = tostring(spellid),
						},
					},
				}
			end
		end
	end
	

	--General Procs
	local genspellargs = {}
	genspellargs = {
		type = 'group',
		name = "Procs for General",
		desc = "Procs for General",
		args = {},
	}
	for spellid,spell in pairs(ProcList) do
		if (spell.ptype ~= nil) and (spell.ptype == 'general') then
			-- checking for "link" spells (ones with different ranks but are linked together cause they are the same spell essentially)
			if ((spell.link == nil) or ((spell.link ~= nil) and (spell.link == 1))) then
				genspellargs.args[tostring(spellid)] = {
					type = 'group',
					name = spell.name,
					desc = spell.name,
					order = spell.optionsOrder or 1,
					args = {
						spellToggle = {
							type = 'toggle',
							name = 'Enabled',
							desc = 'Enable/Disable',
							get = get,
							set = set,
							order = 10,
							arg = tostring(spellid),
						},
						
						spellText = {
							type = 'input',
							name = spell.name,
							desc = 'name of spell',
							get = getname,
							set = setname,
							order = 20,
							arg = tostring(spellid),
						},
						
						spellColor = {
							type = 'color',
							name = 'Color',
							desc = 'color',
							get = getcolor,
							set = setcolor,
							order = 30,
							arg = tostring(spellid),
						},
						
						spellSound = {
							type = 'select',
							name = 'Sound',
							desc = 'Sound to make when proc occurs',
							get = getsound,
							set = setsound,
							order = 40,
							values = {["NONE"] = "None", ["SUNWELL_FEL_PORTALSTAND"] = "Sunwell_Fel_PortalStand", ["SEEPINGGASEOUS_FEL_NOVA"] = "SeepingGaseous_Fel_Nova", ["RAIDWARNING"] = "RaidWarning", ["READYCHECK"] = "ReadyCheck", ["PVPFLAGTAKENHORDEMONO"] = "PVPFlagTakenHordeMono",},
							arg = tostring(spellid),
						},
					},
				}
			end
		end
	end
	-- end General Procs config
	
	local config = LibStub("AceConfig-3.0")
	local dialog = LibStub("AceConfigDialog-3.0")
	
	config:RegisterOptionsTable("QuartzProc-Bliz", {
		name = "QuartzProc",
		type = "group",
		args = {
			help = {
				type = "description",
				name = "Quartz: Procs is module for Quartz that displays Procs/Buffs/Cooldowns on the Mirror module timer list.",
			},
		},
	})
	dialog:SetDefaultSize("QuartzProc-Bliz", 400, 400)
	dialog:AddToBlizOptions("QuartzProc-Bliz", "QuartzProc")

	
	--Current Class Procs
	--LibStub("AceConfig-3.0"):RegisterOptionsTable("QuartzProcs", spellargs)
	config:RegisterOptionsTable("QuartzProc-Class", spellargs)
	QuartzProc.optionsFrame = dialog:AddToBlizOptions("QuartzProc-Class", "Class Procs", "QuartzProc")
	
	--General Procs
	config:RegisterOptionsTable("QuartzProc-General", genspellargs)
	dialog:AddToBlizOptions("QuartzProc-General", "General Procs", "QuartzProc")
	
	--Custom Procs
	config:RegisterOptionsTable("QuartzProc-Custom", CustomOptions)
	dialog:AddToBlizOptions("QuartzProc-Custom", "Custom Procs", "QuartzProc")


    QuartzProc:RegisterChatCommand("quartzprocs", "ChatCommand")
    QuartzProc:RegisterChatCommand("procs", "ChatCommand")
end

function QuartzProc:ChatCommand(input)
	InterfaceOptionsFrame_OpenToCategory(QuartzProc.optionsFrame)
    --if not input or input:trim() == "" then
        --InterfaceOptionsFrame_OpenToCategory(QuartzProc.optionsFrame)
    --else
        --LibStub("AceConfigCmd-3.0").HandleCommand(QuartzProc, "procs", "QuartzProc", input)
    --end
end


function QuartzCustomTimer:OnEnable()
	if db.profile["active"] then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("UNIT_AURA")
		--self:RegisterEvent("PLAYER_TALENT_UPDATE")
	end
end

function QuartzCustomTimer:OnDisable()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:UnregisterEvent("UNIT_AURA")
	--self:UnregisterEvent("PLAYER_TALENT_UPDATE")
end

function QuartzCustomTimer:Enable(doenable)
	if doenable then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("UNIT_AURA")
		--self:RegisterEvent("PLAYER_TALENT_UPDATE")
	else
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:UnregisterEvent("UNIT_AURA")
		--self:UnregisterEvent("PLAYER_TALENT_UPDATE")
	end
	db.profile["active"] = doenable
end


---------------------------------------------
--
--


function QuartzCustomTimer:createProcFrame(sID)
	fproc = CreateFrame("Frame", "ProcFrame", QP.castBarParent)
	fproc:Hide()
	fproc:SetFrameStrata("BACKGROUND")
	fproc:SetWidth(64)
	fproc:SetHeight(64)

	_,_,sIcon = GetSpellInfo(sID)
	tproc = fproc:CreateTexture("ProcTexture","BACKGROUND")
	tproc:SetTexture(sIcon)
	tproc:SetAllPoints(fproc)
	fproc.texture = tproc

	fproc:SetPoint("LEFT", 0, 0)
	fproc:Show()
end

function QuartzCustomTimer:createCustomTimer(sName, sLength, sID, sColor, isCooldown, sPlaySound)
	if (db.profile[sID] ~= nil) then
		if (db.profile[sID].enabled == nil) or (db.profile[sID].enabled == true) then
			local sIcon = ''
			local pColor = db.profile[sID].color or sColor
			if (sID > 0) and (isCooldown == false) then
				_,_,sIcon = GetSpellInfo(sID)
			end
			--- make sure the color is always what is passed if its a cooldown
			if (isCooldown) then
				pColor = sColor
			end
			
			ex[sName] = {
				startTime = GetTime(),
				endTime = GetTime() + sLength,
				icon = sIcon,
				color = pColor,
			}
			m:TriggerEvent("QuartzMirror_UpdateCustom")

			-- Play a sound if found
			if (db.profile[sID].sound ~= nil) and (db.profile[sID].sound ~= "") then
				PlaySound(db.profile[sID].sound)
			elseif (sPlaySound ~= nil) and (sPlaySound ~= "") then
				PlaySound(sPlaySound)
			end
			
			--self:createProcFrame(sID)
		end
	else
		local sIcon = ''
		if (sID > 0) and (isCooldown == false) then
			_,_,sIcon = GetSpellInfo(sID)
		end
		
		ex[sName] = {
			startTime = GetTime(),
			endTime = GetTime() + sLength,
			icon = sIcon,
			color = sColor,
		}
		m:TriggerEvent("QuartzMirror_UpdateCustom")
		
		-- Play a sound if found
		if (sPlaySound ~= nil) and (sPlaySound ~= "") then
			print("sPlaySound..."..sPlaySound)
			PlaySound(sPlaySound)
		end
				
		--self:createProcFrame(sID)
	end
end

-- check talent points for paladin, to update timer lengths
--function QuartzCustomTimer:PLAYER_TALENT_UPDATE()
	--if (curClass == "PALADIN") then
		--checkTalentPoints()
	--end
--end



-- Checks each buff when Aura changes
function QuartzCustomTimer:UNIT_AURA(unit)
	if unit ~= "player" then return end
	
	for kSpellID,vSpell in pairs(spellsWatch) do
		if (vSpell.isAura) then
			local d_name = vSpell.name
			if (db.profile[kSpellID] ~= nil) and (db.profile[kSpellID].name ~= nil) then
				d_name = db.profile[kSpellID].name
			end
			local foundSpell = false
			
			for i=1,40 do
				local name,rank,icon,count,dtype,dur,expr,caster,isStealable,shouldConsolidate,spellId=UnitAura(unit,i)
			
				if name and dur and expr then
					if (spellId == kSpellID) then
						foundSpell = true
						--if (vSpell.expires == 0)  then -- Create Timer
						if (expr ~= vSpell.expires) then -- Create TImer
							vSpell.expires = expr
							self:createCustomTimer(d_name, dur, kSpellID, vSpell.color, false)
							
							if (vSpell.cooldown) then
								local cd_name = d_name
								--TODO: translate this
								cd_name = cd_name .. " Cooldown"
								self:createCustomTimer(cd_name, vSpell.cooldown, spellId, {1,0,0}, true, "")
							end
						end
					end
				end
			end
			if (not foundSpell) then
				vSpell.expires = 0
				if (ex[d_name] ~= nil) then
					ex[d_name] = del(ex[d_name])
					m:TriggerEvent("QuartzMirror_UpdateCustom")
				end
			end
		end
	end
	
end


--[[
-- Checks each buff when Aura changes
function QuartzCustomTimer:UNIT_AURA(unit)
	--print("UNIT_AURA EVENT")
	if unit ~= "player" then return end
	
	for i=1,40 do
		local name,rank,icon,count,dtype,dur,expr,caster,isStealable,shouldConsolidate,spellId=UnitAura(unit,i)
		
		if name and dur and expr then
			--for k,v in pairs(procs_AuraSpells) do
			for k,v in pairs(spellsWatch) do
				if (v.isAura) and (name == v.name) then
					if (expr ~= v.expires) then -- create the timer
						local d_name = name
						if (db.profile[k] ~= nil) and (db.profile[k].name ~= nil) then
							d_name = db.profile[k].name
						end
						-- hacky fix to get sacred shield to work
						-- TODO: use the "new" spellId? :?
						if (v.minlength ~= nil) and (v.maxlength ~= nil) then
							if (dur >= v.minlength) and (dur <= v.maxlength) then
								v.expires = expr
								self:createCustomTimer(d_name, dur, k, v.color, false)
							end
						else
							-- regular isAura event here...
							--print("Spell: '"..name.."' duration: "..dur.." expires in: "..(expr - GetTime()).." secs")
							v.expires = expr
							--print("v.expires == " ..v.expires.. " -- expr == "..expr)
							self:createCustomTimer(d_name, dur, k, v.color, false)
						end
					end
				-- hacky workaround fix for eclipse patch 3.3
				-- TODO: check spellId instead here
				elseif (v.isAura) and (v.icon ~= nil) and (v.icon == icon) then
					if (expr ~= v.expires) then -- create the timer
						local d_name = v.name
						if (db.profile[k] ~= nil) and (db.profile[k].name ~= nil) then
							d_name = db.profile[k].name
						end
						v.expires = expr
						self:createCustomTimer(d_name, dur, k, v.color, false)
						-- patch 3.3 workaround fix for eclipse cooldown
						if (v.cooldown) then
							local cd_name = v.name
							if (db.profile[k] ~= nil) and (db.profile[k].name ~= nil) then
								cd_name = db.profile[k].name
							end
							--TODO: translate this
							cd_name = cd_name .. " Cooldown"
							self:createCustomTimer(cd_name, v.cooldown, k, {1,0,0}, true, "")
						end
					end
				end
			end				
		end
	end
end
]]--

function QuartzCustomTimer:COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	if (destGUID == UnitGUID("player")) then --check if the player is receiving the buff
		local spellID = select(1,...)
		local spellname = select(2,...)
		
		if (event == "SPELL_AURA_APPLIED") or (event == "SPELL_AURA_REFRESH") then
			if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
				-- Make sure it's not a spell that gets added in the UNIT_AURA event
				if (spellsWatch[spellID].isAura == nil) or (spellsWatch[spellID].isAura == false) then
					local d_name = spellsWatch[spellID].name
					if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
						d_name = db.profile[spellID].name
					end

					local s_playsound = spellsWatch[spellID].playsound or "";
					
					--setup the oldname for stack buffs (on application)
					if (spellsWatch[spellID].isStack) and (event == "SPELL_AURA_APPLIED") then
						spellsWatch[spellID].oldname = d_name
					-- if the stacked buff gets refreshed, make sure d_name is the oldname of the spell stack
					elseif (spellsWatch[spellID].isStack) and (event == "SPELL_AURA_REFRESH") then
						d_name = spellsWatch[spellID].oldname
					end
					
					self:createCustomTimer(d_name, spellsWatch[spellID].length, spellID, spellsWatch[spellID].color, false, s_playsound)
					
					if (spellsWatch[spellID].cooldown) then
						local cd_name = spellsWatch[spellID].name
						if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
							cd_name = db.profile[spellID].name
						end
						--TODO: translate this
						cd_name = cd_name .. " Cooldown"
						self:createCustomTimer(cd_name, spellsWatch[spellID].cooldown, spellID, {1,0,0}, true, "")
					end
				end
			end
			
		-- Use this to remove procs that can be consumed (or clicked off, or dispelled)
		elseif (event == "SPELL_AURA_REMOVED") then
			if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
				local d_name = spellsWatch[spellID].name
				if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
					d_name = db.profile[spellID].name
				end
				-- use oldname here for stack buffs (cause they have (2) or whatever in the name)
				if (spellsWatch[spellID].isStack) then
					d_name = spellsWatch[spellID].oldname
				end
				
				if ex[d_name] ~= nil then
					ex[d_name] = del(ex[d_name])
					m:TriggerEvent("QuartzMirror_UpdateCustom")
				end
			-- hacky fix to remove by name (for different ranks that don't have a spellID in the table)
			elseif (ex[spellname] ~= nil) then
				ex[spellname] = del(ex[spellname])
				m:TriggerEvent("QuartzMirror_UpdateCustom")
			end
		
		-- this is for stacking buffs
		-- todo: this only works if the spell stacks are applied sequentily (1,2,3,4...)
		-- and only if spell stacks can't be removed (if i run into a situation that i need it
		-- to work otherwise, gotta redo this code ;( )
		elseif (event == "SPELL_AURA_APPLIED_DOSE") then
			if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
				-- Make sure it's not a spell that gets added in the UNIT_AURA event
				if (spellsWatch[spellID].isAura == nil) or (spellsWatch[spellID].isAura == false)
					and (spellsWatch[spellID].isStack == true)
				then
					local d_name = spellsWatch[spellID].name
					if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
						d_name = db.profile[spellID].name
					end
					local s_playsound = spellsWatch[spellID].playsound or "";
					local spellStack = select(5,...)
					
					-- remove the old timer
					if (spellsWatch[spellID].oldname ~= "") then
						if (ex[spellsWatch[spellID].oldname] ~= nil) then
							ex[spellsWatch[spellID].oldname] = del(ex[spellsWatch[spellID].oldname])
							m:TriggerEvent("QuartzMirror_UpdateCustom")
						end
					end
					
					--update the spell name with the # of stacks
					d_name = d_name .. " ("..spellStack..")"
					spellsWatch[spellID].oldname = d_name
					
					self:createCustomTimer(d_name, spellsWatch[spellID].length, spellID, spellsWatch[spellID].color, false, s_playsound)
					
					--TODO: add cooldown code here if we ever need a cooldown for stacking buffs
				end
			end
		end
		
	-- kind of a hacky fix to get Treants to work
	elseif (event == "SPELL_CAST_SUCCESS") and (sourceGUID == UnitGUID("player")) then
		local spellID = select(1,...)
		local spellname = select(2,...)
		if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
			if (spellsWatch[spellID].isSpellCast ~= nil)  and (spellsWatch[spellID].isSpellCast == true)
			then
				local d_name = spellsWatch[spellID].name
				if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
					d_name = db.profile[spellID].name
				end
				local s_playsound = spellsWatch[spellID].playsound or "";
				
				self:createCustomTimer(d_name, spellsWatch[spellID].length, spellID, spellsWatch[spellID].color, false, s_playsound)
			end
		end
	end
	
end
